AddCSLuaFile()

ENT.Type = "anim"
ENT.Base = "long_use_base"
 
ENT.PrintName= "Garbage"
ENT.Author= "SweptThrone"
ENT.Contact= "https://sweptthr.one/discord"
ENT.Purpose= ""
ENT.Instructions= ""
ENT.Spawnable = true
ENT.AdminSpawnable = false
ENT.Category = "STGarbageCollector"

ENT.TimeToUse = 7.5

ENT.PartialUses = {}

local pickupSounds = {
    "physics/cardboard/cardboard_box_impact_soft1.wav",
    "physics/cardboard/cardboard_box_impact_soft2.wav",
    "physics/cardboard/cardboard_box_impact_soft3.wav",
    "physics/glass/glass_impact_soft1.wav",
    "physics/glass/glass_impact_soft2.wav",
    "physics/glass/glass_impact_soft3.wav",
    "physics/wood/wood_crate_impact_soft1.wav",
    "physics/wood/wood_crate_impact_soft2.wav",
    "physics/wood/wood_crate_impact_soft3.wav",
    "physics/metal/soda_can_impact_soft1.wav",
    "physics/metal/soda_can_impact_soft2.wav",
    "physics/metal/soda_can_impact_soft3.wav",
    "physics/plastic/plastic_barrel_impact_soft1.wav",
    "physics/plastic/plastic_barrel_impact_soft2.wav",
    "physics/plastic/plastic_barrel_impact_soft3.wav"
}

for i = 0, 95, 5 do
    table.insert( ENT.PartialUses, { prog = i, func = function( this ) if SERVER then this:EmitSound( Sound( table.Random( pickupSounds ) ) ) end end } )
end

if CLIENT then

    function ENT:Initialize()
    end

    function ENT:Draw()
        self:DrawModel()
    end
end

if SERVER then
    local models = {
        "models/props_junk/garbage256_composite001a.mdl",
        "models/props_junk/garbage256_composite001b.mdl",
        "models/props_junk/garbage128_composite001c.mdl",
        "models/props_junk/garbage128_composite001d.mdl",
        "models/props_junk/garbage128_composite001a.mdl",
        "models/props_junk/garbage128_composite001b.mdl",
        "models/props_junk/garbage256_composite002a.mdl",
        "models/props_junk/garbage256_composite002b.mdl"
    }

    function ENT:Initialize()
    
        self:SetModel( table.Random( models ) )
        self:PhysicsInit( SOLID_VPHYSICS )
        self:SetMoveType( MOVETYPE_VPHYSICS )
        self:SetSolid( SOLID_VPHYSICS )
        self:SetCollisionGroup( COLLISION_GROUP_DEBRIS )

        self:SetDrawKeyPrompt( false )
    
        local phys = self:GetPhysicsObject()
        if (phys:IsValid()) then phys:EnableMotion( false ) end
        self:SetUseType( CONTINUOUS_USE )

    end
    
    function ENT:OnUseFinish( ply )
		self:EmitSound( "items/gift_pickup.wav" )
        ply:SetNWInt( "HeldTrash", ply:GetNWInt( "HeldTrash", 0 ) + 1 )
        self:SetModelScale( 0, 1 )
        self:DrawShadow( false )
        self.MFD = true
        timer.Simple( 1, function()
            self:Remove()
        end )
    end

    function ENT:OnUseStart( ply )
        if self.MFD then self:CancelUse() end
        if ply:GetNWInt( "HeldTrash", 0 ) >= ST_CONFIGS[ "STGarbageCollector" ][ "MaxHeldGarbage" ] then
            self:CancelUse( true )
            if DarkRP then
                DarkRP.notify( ply, 1, 5, "You cannot carry any more garbage." )
            else
                ply:ChatPrint( "You cannot carry any more garbage." )
            end
        end
    end

    function ENT:OnUseCancel()
    end

end