AddCSLuaFile()

ENT.Type = "anim"
ENT.Base = "base_anim"
 
ENT.PrintName= "Garbage Bag"
ENT.Author= "SweptThrone"
ENT.Contact= "https://sweptthr.one/discord"
ENT.Purpose= ""
ENT.Instructions= ""
ENT.Spawnable = true
ENT.AdminSpawnable = false
ENT.Category = "STGarbageCollector"

if CLIENT then

    function ENT:Initialize()
    end

    function ENT:Draw()
        self:DrawModel()
    end
end

if SERVER then

    function ENT:Initialize()
    
        self:SetModel( "models/sweptthrone/garbage_bag" .. math.random( 1, 2 ) .. math.random( 1, 5 ) .. ".mdl" )
        self:PhysicsInit( SOLID_VPHYSICS )
        self:SetMoveType( MOVETYPE_VPHYSICS )
        self:SetSolid( SOLID_VPHYSICS )
        self:SetCollisionGroup( COLLISION_GROUP_DEBRIS )
    
        local phys = self:GetPhysicsObject()
        if (phys:IsValid()) then phys:Wake() end
        self:SetUseType( SIMPLE_USE )

        timer.Create( "cleanselfup" .. self:EntIndex(), ST_CONFIGS[ "STGarbageCollector" ][ "BagDespawnTime" ], 1, function()
            if IsValid( self ) then
                local ed = EffectData()
                ed:SetOrigin( self:GetPos() + Vector( 0, 0, 5 ) )
                ed:SetStart( self:GetModel()[ 31 ] == "1" and Vector( 255, 255, 255 ) or Vector( 0, 0, 0 ) )
                util.Effect( "balloon_pop", ed )
                self:Remove()
            end
        end )

    end
    
    function ENT:Use( ply )
        if ply:GetNWInt( "HeldTrash", 0 ) >= ST_CONFIGS[ "STGarbageCollector" ][ "MaxHeldGarbage" ] then
            if DarkRP then
                DarkRP.notify( ply, 1, 5, "You cannot carry any more garbage." )
            else
                ply:ChatPrint( "You cannot carry any more garbage." )
            end
            return
        end

		self:EmitSound( "items/gift_pickup.wav" )
        ply:SetNWInt( "HeldTrash", ply:GetNWInt( "HeldTrash", 0 ) + 1 )
        timer.Remove( "cleanselfup" .. self:EntIndex() )
        self:Remove()
    end

end